#! /bin/bash

# Public Domain

if [ -n "$UPDATEDL" ]
then
  unset UPDATEDL
  ./makinst.sh
  ./mak.sh
  exit $?
fi

rm -f bin/ldos.com
rm -f bin/ldos.sys
rm -f bin/ldospak.com
rm -f bin/ldospak.sys

if ! make
then
  exit $?
fi
cp -a src/BIOS/msbio.bin .
cp -a src/CMD/SHARE/share.exe .

nocommandtracelist=0
if [ "$1" == "onlypl" ]
then
  shift
elif [ "$1" == "onlykern" ]
then
  nocommandtracelist=1
  shift
else
  [[ -z "$DOSEMU" ]] && DOSEMU=dosemu
  "$DOSEMU" -dumb -td -kt < /dev/null -K "$PWD" -E "mak.bat"
fi

notracelist=0
if [[ "$1" == "notracelist" ]]
then
  shift
  notracelist=1
fi

nasm version.asm -I src/INC/ -o tmp/version.com -l lst/version.lst
nasm comload.asm -I src/INC/ -o tmp/payload2.com -l lst/comload.lst
build_name=ldos build_pack_name=ldospak build_unpack_name=ldos \
  build_kernpl_module=lkernpl build_version_com=0 ../kernwrap/mak.sh

if ! (( notracelist ))
then
  echo === Creating kernel trace listing
  (cd src/BIOS/;
  cat MSBIO.LNK |
  grep -Eio '\S+\.obj' |
  sed -re 's/\\/\//g;s/\.obj/\.lst/g;s/\/inc\//\/INC\//g;s/\/dos\//\/DOS\//g' |
  xargs -n 999 -x convlist.pl msbiow.map > msbio.tls)
fi

if ! (( notracelist + nocommandtracelist ))
then
  echo === Creating COMMAND trace listing
  (cd src/CMD/COMMAND/;
  cat COMMAND.LNK |
  grep -Eio '\S+\.obj' |
  sed -re 's/\\/\//g;s/\.obj/\.lst/g;s/\/inc\//\/INC\//g' |
  xargs convlist.pl command.map > command.tls)
fi
